VERSION 5.00
Begin VB.Form frmPlugin 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FF00FF&
   BorderStyle     =   0  'None
   ClientHeight    =   2985
   ClientLeft      =   120
   ClientTop       =   120
   ClientWidth     =   9720
   ControlBox      =   0   'False
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   199
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   648
   ShowInTaskbar   =   0   'False
   Begin VB.PictureBox picTemp 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FF00FF&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   375
      Left            =   -1920
      ScaleHeight     =   375
      ScaleWidth      =   495
      TabIndex        =   1
      Top             =   0
      Width           =   495
      Visible         =   0   'False
   End
   Begin VB.PictureBox picTasks 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   270
      Index           =   0
      Left            =   0
      ScaleHeight     =   18
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   56
      TabIndex        =   0
      Tag             =   "0"
      Top             =   0
      Width           =   840
      Visible         =   0   'False
   End
End
Attribute VB_Name = "frmPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Settings loaded from the settings modules
Public BorderTop As Long
Public BorderLeft As Long
Public wrapcount As Long
Public direction As String
Public wrapdirection As String
Public maxX As Long
Public maxY As Long
Public maxLength As Long
Public TileBackground As String
Public TileSpaceX As Long
Public TileSpaceY As Long
Public TileSelected As String
Public TitleX As Long
Public TitleY As Long
Public TitleFont As String
Public TitleFontSize As Long
Public TitleFontColor As String
Public IconX As Long
Public IconY As Long
Public IconHeight As Long
Public IconWidth As Long
Public hidetitle As Boolean
Public hideicon As Boolean

' Runtime settings
Public CurAct As Long
Private Sub picTasks_Click(index As Integer)

    Call ShowWindow(picTasks(index).Tag, SW_RESTORE)
    Call SetForegroundWindow(picTasks(index).Tag)

End Sub
Private Sub picTasks_MouseDown(index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

    Dim hMenu As Long
    Dim result As Long
    Dim p As POINTAPI
    Dim RC As RECT
    
    If Button = 2 Then
        hMenu = GetSystemMenu(picTasks(index).Tag, False)
        Call GetCursorPos(p)
        result = TrackPopupMenu(hMenu, TPM_RETURNCMD Or TPM_LEFTBUTTON, p.X, p.Y, 0, Me.hwnd, RC)
        If result Then
            SendMessage picTasks(index).Tag, WM_SYSCOMMAND, result, p
        End If
        DestroyMenu (hMenu)
    End If

End Sub
Private Sub picTasks_MouseMove(index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

    Dim j As Long
    
    If IsWindow(picTasks(index).Tag) = 0 Then
        For j = index To picTasks.Count - 2
            picTasks(j).Tag = picTasks(j + 1).Tag
        Next j
        Unload picTasks(picTasks.Count - 1)
    End If

End Sub
Public Sub picTasks_Paint(index As Integer)

    Dim intLen As Long
    Dim strTitle As String
    Dim flags As Long
    Dim m_HungTimeout As Long
    Dim hIconSm As Long
    Dim j As Integer
    
    If picTasks(index).Tag = "" Then
        For j = index To picTasks.Count - 2
            picTasks(j).Tag = picTasks(j + 1).Tag
            picTasks_Paint j
        Next j
        Unload picTasks(picTasks.Count - 1)
    Else
        intLen = GetWindowTextLength(CLng(picTasks(index).Tag)) + 1
        strTitle = Space$(intLen)
        strTitle = Left(strTitle, Len(strTitle) - 1)
        intLen = GetWindowText(CLng(picTasks(index).Tag), strTitle, intLen)
        If Not hideicon Then
            If SendMessageTimeout(CLng(picTasks(index).Tag), WM_GETICON, ICON_SMALL, ByVal 0&, flags, m_HungTimeout, hIconSm) Then
                If hIconSm = 0 Then
                    If SendMessageTimeout(CLng(picTasks(index).Tag), WM_GETICON, ICON_BIG, ByVal 0&, flags, m_HungTimeout, hIconSm) Then
                        If hIconSm = 0 Then
                            hIconSm = GetClassLong(CLng(picTasks(index).Tag), GCL_HICONSM)
                            If hIconSm = 0 Then
                                hIconSm = GetClassLong(CLng(picTasks(index).Tag), GCL_HICON)
                            End If
                        End If
                    End If
                End If
            End If
        End If
        If CLng(picTasks(index).Tag) = CurAct Then
            picTasks(index).Picture = LoadPicture(TileSelected)
        Else
            picTasks(index).Picture = LoadPicture(TileBackground)
        End If
        picTasks(index).CurrentY = 0
        picTasks(index).CurrentX = 0
        picTemp.Cls
        If Not hideicon Then
            picTemp.Picture = CreatePicture(hIconSm, vbPicTypeIcon)
            picTemp.Refresh
            TransparentBlt picTasks(index).hDC, IconX, IconY, IconWidth, IconHeight, picTemp.hDC, 0, 0, picTemp.Width, picTemp.Height, &HFF00FF
        End If
        picTasks(index).CurrentX = TitleX
        picTasks(index).CurrentY = TitleY
        picTasks(index).Font = TitleFont
        picTasks(index).FontSize = TitleFontSize
        picTasks(index).ForeColor = TitleFontColor
        picTasks(index).ToolTipText = strTitle
        If Not hidetitle Then
            If (TextWidth(strTitle) > maxLength) And (maxLength > 0) Then
                While TextWidth(strTitle & "...") > maxLength
                    strTitle = Left(strTitle, Len(strTitle) - 1)
                Wend
                strTitle = strTitle & "..."
            End If
            picTasks(index).Print strTitle
        End If
    End If

End Sub
Public Sub setup()

    Dim textline As String

    hideicon = oServer.evalBool(oServer.GetKey(Me.Tag, "hideicon"))
    hidetitle = oServer.evalBool(oServer.GetKey(Me.Tag, "hidetitle"))
    wrapdirection = oServer.GetKey(Me.Tag, "WrapDirection")
    direction = oServer.GetKey(Me.Tag, "Direction")
    wrapcount = oServer.evalNum(oServer.GetKey(Me.Tag, "WrapCount"))
    maxLength = oServer.evalNum(oServer.GetKey(Me.Tag, "TitleMaxLength"))
    textline = oServer.GetKey(Me.Tag, "TileSpaceX")
    If textline <> "" Then
       TileSpaceX = oServer.evalNum(textline)
    End If
    textline = oServer.GetKey(Me.Tag, "TileSpaceY")
    If textline <> "" Then
        TileSpaceY = oServer.evalNum(textline)
    End If
    textline = oServer.GetKey(Me.Tag, "BorderTop")
    If textline <> "" Then
        BorderTop = oServer.evalNum(textline)
    End If
    textline = oServer.GetKey(Me.Tag, "BorderLeft")
    If textline <> "" Then
        BorderLeft = oServer.evalNum(textline)
    End If
    TileSelected = oServer.GetKey(Me.Tag, "TileSelected")
    If TileSelected = "" Then
        TileSelected = oServer.GetKey(Me.Tag, "TileBackground")
    End If
    TitleX = oServer.evalNum(oServer.GetKey(Me.Tag, "TitleX"))
    TitleY = oServer.evalNum(oServer.GetKey(Me.Tag, "TitleY"))
    TitleFont = oServer.GetKey(Me.Tag, "TitleFont")
    TitleFontSize = oServer.evalNum(oServer.GetKey(Me.Tag, "TitleFontSize"))
    TitleFontColor = "&H" & oServer.GetKey(Me.Tag, "TitleFontColor")
    If InStr(TitleFontColor, "&H") = 0 Then
        TitleFontColor = "&H" & TitleFontColor
    End If
    IconX = oServer.evalNum(oServer.GetKey(Me.Tag, "IconX"))
    IconY = oServer.evalNum(oServer.GetKey(Me.Tag, "IconY"))
    IconWidth = oServer.evalNum(oServer.GetKey(Me.Tag, "IconWidth"))
    IconHeight = oServer.evalNum(oServer.GetKey(Me.Tag, "IconHeight"))

End Sub
Public Function CreatePicture(ByVal hImage As Long, Optional ByVal PicType As PictureTypeConstants = vbPicTypeBitmap, Optional Data1 As Long = 0, Optional Data2 As Long = 0) As IPicture
   
    Dim r As Long
    Dim Pic As PictDesc
    Dim ipic As IPicture
    Dim IID_IDispatch As GUID
    
    With IID_IDispatch
       .Data1 = &H20400
       .Data4(0) = &HC0
       .Data4(7) = &H46
    End With
    
    With Pic
       .Size = Len(Pic)
       .Type = PicType
       .hImage = hImage
       .Data1 = Data1
       .Data2 = Data2
    End With
    
    r = OleCreatePictureIndirect(Pic, IID_IDispatch, False, ipic)
    Set CreatePicture = ipic

End Function
